/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdlib.h>


typedef enum {
  /**
   * Resets all the attributes.
   */
  CROSSTERM_ATTRIBUTE_RESET,
  /**
   * Increases the text intensity.
   */
  CROSSTERM_ATTRIBUTE_BOLD,
  /**
   * Decreases the text intensity.
   */
  CROSSTERM_ATTRIBUTE_DIM,
  /**
   * Emphasises the text.
   */
  CROSSTERM_ATTRIBUTE_ITALIC,
  /**
   * Underlines the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERLINED,
  /**
   * Double underlines the text.
   */
  CROSSTERM_ATTRIBUTE_DOUBLE_UNDERLINED,
  /**
   * Undercurls the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERCURLED,
  /**
   * Underdots the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERDOTTED,
  /**
   * Underdashes the text.
   */
  CROSSTERM_ATTRIBUTE_UNDERDASHED,
  /**
   * Makes the text blinking (< 150 per minute).
   */
  CROSSTERM_ATTRIBUTE_SLOW_BLINK,
  /**
   * Makes the text blinking (>= 150 per minute).
   */
  CROSSTERM_ATTRIBUTE_RAPID_BLINK,
  /**
   * Swaps foreground and background colors.
   */
  CROSSTERM_ATTRIBUTE_REVERSE,
  /**
   * Hides the text (also known as Conceal).
   */
  CROSSTERM_ATTRIBUTE_HIDDEN,
  /**
   * Crosses the text.
   */
  CROSSTERM_ATTRIBUTE_CROSSED_OUT,
  /**
   * Sets the [Fraktur](https://en.wikipedia.org/wiki/Fraktur) typeface.
   *
   * Mostly used for [mathematical alphanumeric symbols](https://en.wikipedia.org/wiki/Mathematical_Alphanumeric_Symbols).
   */
  CROSSTERM_ATTRIBUTE_FRAKTUR,
  /**
   * Turns off the `Bold` attribute. - Inconsistent - Prefer to use NormalIntensity
   */
  CROSSTERM_ATTRIBUTE_NO_BOLD,
  /**
   * Switches the text back to normal intensity (no bold, italic).
   */
  CROSSTERM_ATTRIBUTE_NORMAL_INTENSITY,
  /**
   * Turns off the `Italic` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_ITALIC,
  /**
   * Turns off the `Underlined` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_UNDERLINE,
  /**
   * Turns off the text blinking (`SlowBlink` or `RapidBlink`).
   */
  CROSSTERM_ATTRIBUTE_NO_BLINK,
  /**
   * Turns off the `Reverse` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_REVERSE,
  /**
   * Turns off the `Hidden` attribute.
   */
  CROSSTERM_ATTRIBUTE_NO_HIDDEN,
  /**
   * Turns off the `CrossedOut` attribute.
   */
  CROSSTERM_ATTRIBUTE_NOT_CROSSED_OUT,
  /**
   * Makes the text framed.
   */
  CROSSTERM_ATTRIBUTE_FRAMED,
  /**
   * Makes the text encircled.
   */
  CROSSTERM_ATTRIBUTE_ENCIRCLED,
  /**
   * Draws a line at the top of the text.
   */
  CROSSTERM_ATTRIBUTE_OVER_LINED,
  /**
   * Turns off the `Frame` and `Encircled` attributes.
   */
  CROSSTERM_ATTRIBUTE_NOT_FRAMED_OR_ENCIRCLED,
  /**
   * Turns off the `OverLined` attribute.
   */
  CROSSTERM_ATTRIBUTE_NOT_OVER_LINED,
} crossterm_Attribute;

/**
 * Different ways to clear the terminal buffer.
 */
typedef enum {
  /**
   * All cells.
   */
  CROSSTERM_CLEAR_TYPE_ALL,
  /**
   * All plus history
   */
  CROSSTERM_CLEAR_TYPE_PURGE,
  /**
   * All cells from the cursor position downwards.
   */
  CROSSTERM_CLEAR_TYPE_FROM_CURSOR_DOWN,
  /**
   * All cells from the cursor position upwards.
   */
  CROSSTERM_CLEAR_TYPE_FROM_CURSOR_UP,
  /**
   * All cells at the cursor row.
   */
  CROSSTERM_CLEAR_TYPE_CURRENT_LINE,
  /**
   * All cells from the cursor position until the new line.
   */
  CROSSTERM_CLEAR_TYPE_UNTIL_NEW_LINE,
} crossterm_ClearType;

/**
 * Style of the cursor.
 * It uses two types of escape codes, one to control blinking, and the other the shape.
 */
typedef enum {
  /**
   * Default cursor shape configured by the user.
   */
  CROSSTERM_CURSOR_STYLE_DEFAULT_USER_SHAPE,
  /**
   * A blinking block cursor shape (■).
   */
  CROSSTERM_CURSOR_STYLE_BLINKING_BLOCK,
  /**
   * A non blinking block cursor shape (inverse of `BlinkingBlock`).
   */
  CROSSTERM_CURSOR_STYLE_STEADY_BLOCK,
  /**
   * A blinking underscore cursor shape(_).
   */
  CROSSTERM_CURSOR_STYLE_BLINKING_UNDER_SCORE,
  /**
   * A non blinking underscore cursor shape (inverse of `BlinkingUnderScore`).
   */
  CROSSTERM_CURSOR_STYLE_STEADY_UNDER_SCORE,
  /**
   * A blinking cursor bar shape (|)
   */
  CROSSTERM_CURSOR_STYLE_BLINKING_BAR,
  /**
   * A steady cursor bar shape (inverse of `BlinkingBar`).
   */
  CROSSTERM_CURSOR_STYLE_STEADY_BAR,
} crossterm_CursorStyle;

/**
 * CursorPosition struct
 */
typedef struct {
  uint16_t column;
  uint16_t row;
} crossterm_CursorPosition;

typedef enum {
  /**
   * Resets the terminal color.
   */
  CROSSTERM_COLOR_RESET,
  /**
   * Black color.
   */
  CROSSTERM_COLOR_BLACK,
  /**
   * Dark grey color.
   */
  CROSSTERM_COLOR_DARK_GREY,
  /**
   * Light red color.
   */
  CROSSTERM_COLOR_RED,
  /**
   * Dark red color.
   */
  CROSSTERM_COLOR_DARK_RED,
  /**
   * Light green color.
   */
  CROSSTERM_COLOR_GREEN,
  /**
   * Dark green color.
   */
  CROSSTERM_COLOR_DARK_GREEN,
  /**
   * Light yellow color.
   */
  CROSSTERM_COLOR_YELLOW,
  /**
   * Dark yellow color.
   */
  CROSSTERM_COLOR_DARK_YELLOW,
  /**
   * Light blue color.
   */
  CROSSTERM_COLOR_BLUE,
  /**
   * Dark blue color.
   */
  CROSSTERM_COLOR_DARK_BLUE,
  /**
   * Light magenta color.
   */
  CROSSTERM_COLOR_MAGENTA,
  /**
   * Dark magenta color.
   */
  CROSSTERM_COLOR_DARK_MAGENTA,
  /**
   * Light cyan color.
   */
  CROSSTERM_COLOR_CYAN,
  /**
   * Dark cyan color.
   */
  CROSSTERM_COLOR_DARK_CYAN,
  /**
   * White color.
   */
  CROSSTERM_COLOR_WHITE,
  /**
   * Grey color.
   */
  CROSSTERM_COLOR_GREY,
  /**
   * An RGB color. See [RGB color model](https://en.wikipedia.org/wiki/RGB_color_model) for more info.
   *
   * Most UNIX terminals and Windows 10 supported only.
   */
  CROSSTERM_COLOR_RGB,
  /**
   * An ANSI color. See [256 colors - cheat sheet](https://jonasjacek.github.io/colors/) for more info.
   *
   * Most UNIX terminals and Windows 10 supported only.
   */
  CROSSTERM_COLOR_ANSI_VALUE,
} crossterm_Color_Tag;

typedef struct {
  uint8_t r;
  uint8_t g;
  uint8_t b;
} crossterm_Rgb_Body;

typedef struct {
  crossterm_Color_Tag tag;
  union {
    crossterm_Rgb_Body RGB;
    struct {
      uint8_t ansi_value;
    };
  };
} crossterm_Color;

/**
 * TerminalSize
 */
typedef struct {
  uint16_t width;
  uint16_t height;
} crossterm_TerminalSize;

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

void crossterm_clear_last_error(void);

/**
 * Disables blinking of the terminal cursor.
 */
int crossterm_cursor_disable_blinking(void);

/**
 * Enables blinking of the terminal cursor.
 */
int crossterm_cursor_enable_blinking(void);

/**
 * Hides the terminal cursor.
 */
int crossterm_cursor_hide(void);

/**
 * Moves the terminal cursor a given number of rows down.
 */
int crossterm_cursor_move_down(uint16_t rows);

/**
 * Moves the terminal cursor a given number of columns to the left.
 */
int crossterm_cursor_move_left(uint16_t columns);

/**
 * Moves the terminal cursor a given number of columns to the right.
 */
int crossterm_cursor_move_right(uint16_t columns);

/**
 * Moves the terminal cursor to the given column on the current row.
 */
int crossterm_cursor_move_to_column(uint16_t column);

/**
 * Moves the terminal cursor down the given number of lines and moves it to the first column.
 *
 * # Notes
 * * This command is 1 based, meaning `crossterm_cursor_move_to_next_line(1)` moves to the next line.
 * * Most terminals default 0 argument to 1.
 */
int crossterm_cursor_move_to_next_line(uint16_t n);

/**
 * Moves the terminal cursor up the given number of lines and moves it to the first column.
 */
int crossterm_cursor_move_to_previous_line(uint16_t n);

/**
 * Moves the terminal cursor to the given row on the current column.
 */
int crossterm_cursor_move_to_row(uint16_t row);

/**
 * Moves the terminal cursor a given number of rows up.
 */
int crossterm_cursor_move_up(uint16_t rows);

/**
 * Moves the terminal cursor to the given position (column, row).
 *
 * # Notes
 * * Top left cell is represented as `0,0`.
 */
int crossterm_cursor_moveto(uint16_t x, uint16_t y);

/**
 * Get cursor position (column, row)
 */
int crossterm_cursor_position_get(crossterm_CursorPosition *pos);

/**
 * Set cursor position (column, row)
 */
int crossterm_cursor_position_set(crossterm_CursorPosition pos);

/**
 * Restores the saved terminal cursor position.
 */
int crossterm_cursor_restore_position(void);

/**
 * Saves the current terminal cursor position.
 */
int crossterm_cursor_save_position(void);

/**
 * Sets the style of the cursor.
 */
int crossterm_cursor_set_style(crossterm_CursorStyle cursor_style);

/**
 * Sets the style of the cursor to a blinking bar.
 */
int crossterm_cursor_set_style_blinking_bar(void);

/**
 * Sets the style of the cursor to a blinking block.
 */
int crossterm_cursor_set_style_blinking_block(void);

/**
 * Sets the style of the cursor to a blinking underscore.
 */
int crossterm_cursor_set_style_blinking_underscore(void);

/**
 * Sets the style of the cursor to default user shape.
 */
int crossterm_cursor_set_style_default_user_shape(void);

/**
 * Sets the style of the cursor to a steady bar.
 */
int crossterm_cursor_set_style_steady_bar(void);

/**
 * Sets the style of the cursor to a steady block.
 */
int crossterm_cursor_set_style_steady_block(void);

/**
 * Sets the style of the cursor to a steady underscore.
 */
int crossterm_cursor_set_style_steady_underscore(void);

/**
 * Shows the terminal cursor.
 */
int crossterm_cursor_show(void);

/**
 * Disables line wrapping.
 */
int crossterm_disable_line_wrap(void);

/**
 * Enables line wrapping.
 */
int crossterm_enable_line_wrap(void);

/**
 * Enters alternate screen.
 */
int crossterm_enter_alternate_screen(void);

/**
 * Disables bracketed paste mode.
 */
int crossterm_event_disable_bracketed_paste(void);

/**
 * Disable focus event emission.
 */
int crossterm_event_disable_focus_change(void);

/**
 * Disable mouse event capturing.
 */
int crossterm_event_disable_mouse_capture(void);

/**
 * Enables [bracketed paste mode](https://en.wikipedia.org/wiki/Bracketed-paste).
 *
 * It should be paired with [`crossterm_event_disable_bracketed_paste`] at the end of execution.
 *
 * This is not supported in older Windows terminals without
 * [virtual terminal sequences](https://docs.microsoft.com/en-us/windows/console/console-virtual-terminal-sequences).
 */
int crossterm_event_enable_bracketed_paste(void);

/**
 * Enable focus event emission.
 *
 * It should be paired with [`crossterm_event_disable_focus_change`] at the end of execution.
 *
 * Focus events can be captured with [`crossterm_event_read`].
 */
int crossterm_event_enable_focus_change(void);

/**
 * Enable mouse event capturing.
 */
int crossterm_event_enable_mouse_capture(void);

/**
 * Checks if there is an `Event` available.
 *
 * Returns `true` if an `Event` is available otherwise it returns `false`.
 *
 * `true` guarantees that subsequent call to the [`crossterm_event_read`] function
 * won't block.
 *
 * # Arguments
 *
 * * `timeout_secs` - maximum waiting time for event availability
 * * `timeout_nanos` - maximum waiting time for event availability
 */
int crossterm_event_poll(uint64_t secs, uint32_t nanos);

/**
 * Disables extra kinds of keyboard events.
 */
int crossterm_event_pop_keyboard_enhancement_flags(void);

/**
 * Enables the [kitty keyboard protocol](https://sw.kovidgoyal.net/kitty/keyboard-protocol/),
 * which adds extra information to keyboard events and removes ambiguity for modifier keys.
 * It should be paired with [`crossterm_pop_keyboard_enhancement_flags`] at the end of execution.
 */
int crossterm_event_push_keyboard_enhancement_flags(uint8_t flags);

/**
 * Reads a single Event as a UTF-8 json string.
 *
 * This function blocks until an Event is available.
 * Combine it with the [`crossterm_event_poll`] function to get non-blocking reads.
 * User is responsible to free string. Use [`crossterm_free_c_char`] to free data
 */
const char *crossterm_event_read(void);

int crossterm_free_c_char(char *s);

/**
 * Check whether error has been set.
 */
bool crossterm_has_error(void);

/**
 * Calculate the number of bytes in the last error's error message including a
 * trailing `null` character. If there are no recent error, then this returns
 * `0`.
 */
int crossterm_last_error_length(void);

/**
 * Return most recent error message into a UTF-8 string buffer.
 *
 * Null character is stored in the last location of buffer.
 * Caller is responsible to memory associated with string buffer.
 * Use [`crossterm_free_c_char`] to free data.
 */
const char *crossterm_last_error_message(void);

/**
 * Leaves alternate screen.
 */
int crossterm_leave_alternate_screen(void);

/**
 * Sleeps for `seconds` seconds
 */
void crossterm_sleep(double seconds);

/**
 * Resets the colors back to default.
 */
int crossterm_style_reset_color(void);

/**
 * Sets an attribute.
 *
 * See [`Attribute`] for more info.
 */
int crossterm_style_set_attribute(crossterm_Attribute attr);

/**
 * Sets the the background color.
 *
 * See [`Color`] for more info.
 */
int crossterm_style_set_background_color(crossterm_Color color);

/**
 * Sets the the foreground color.
 *
 * See [`Color`] for more info.
 */
int crossterm_style_set_foreground_color(crossterm_Color color);

/**
 * Sets the the underline color.
 *
 * See [`Color`] for more info.
 */
int crossterm_style_set_underline_color(crossterm_Color color);

/**
 * Instructs the terminal emulator to begin a synchronized frame.
 *
 * # Notes
 *
 * * Commands must be executed/queued for execution otherwise they do nothing.
 * * Use [`crossterm_terminal_end_synchronized_update`] command to leave the entered alternate screen.
 *
 * When rendering the screen of the terminal, the Emulator usually iterates through each visible grid cell and
 * renders its current state. With applications updating the screen a at higher frequency this can cause tearing.
 *
 * This mode attempts to mitigate that.
 *
 * When the synchronization mode is enabled following render calls will keep rendering the last rendered state.
 * The terminal Emulator keeps processing incoming text and sequences. When the synchronized update mode is disabled
 * again the renderer may fetch the latest screen buffer state again, effectively avoiding the tearing effect
 * by unintentionally rendering in the middle a of an application screen update.
 */
int crossterm_terminal_begin_synchronized_update(void);

/**
 * Clear screen command.
 */
int crossterm_terminal_clear(crossterm_ClearType ct);

/**
 * Disables raw mode.
 */
int crossterm_terminal_disable_raw_mode(void);

/**
 * Enables raw mode.
 */
int crossterm_terminal_enable_raw_mode(void);

/**
 * Instructs the terminal to end a synchronized frame.
 *
 * # Notes
 *
 * * Commands must be executed/queued for execution otherwise they do nothing.
 * * Use [`crossterm_terminal_begin_synchronized_update`] to enter the alternate screen.
 *
 * When rendering the screen of the terminal, the Emulator usually iterates through each visible grid cell and
 * renders its current state. With applications updating the screen a at higher frequency this can cause tearing.
 *
 * This mode attempts to mitigate that.
 *
 * When the synchronization mode is enabled following render calls will keep rendering the last rendered state.
 * The terminal Emulator keeps processing incoming text and sequences. When the synchronized update mode is disabled
 * again the renderer may fetch the latest screen buffer state again, effectively avoiding the tearing effect
 * by unintentionally rendering in the middle a of an application screen update.
 */
int crossterm_terminal_end_synchronized_update(void);

/**
 * Scroll down command.
 */
int crossterm_terminal_scroll_down(unsigned short n);

/**
 * Scroll up command.
 */
int crossterm_terminal_scroll_up(unsigned short n);

/**
 * Sets the terminal buffer size `(columns, rows)`.
 */
int crossterm_terminal_set_size(uint16_t columns, uint16_t rows);

/**
 * Sets terminal title.
 *
 * # Safety
 *
 * This function takes a raw pointer as argument. As such, the caller must ensure that:
 * - The `title` pointer points to a valid null-terminated string.
 * - This function borrows a slice to a valid null-terminated string and the memory referenced by `title` won't be deallocated or modified for the duration of the function call..
 * - The `title` pointer is correctly aligned and `title` points to an initialized memory.
 *
 * If these conditions are not met, the behavior is undefined.
 */
int crossterm_terminal_set_title(const char *title);

/**
 * Get terminal size
 */
int crossterm_terminal_size(crossterm_TerminalSize *size);

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus
